Can I get express error handler to catch exceptions thrown inside of a mongoose callback?

Problem

Setup: nodejs, express, mongodb, mongoose

Relevant code:

var express = require('express');
var server = express();
server.use(express.bodyParser());
server.use(express.methodOverride());
server.use(server.router);

var mongoose = require('mongoose');
mongoose.connect('localhost', 'test');
var Schema = mongoose.Schema;
var VehicleSchema = new Schema({
    name : String
}, {collection: 'vehicles'});
var Vehicle = mongoose.model('vehicle', VehicleSchema);

server.use(clientErrorHandler);
function clientErrorHandler(err, req, res, next) {
    console.log('client error handler found', err);
    res.send(500, err);
}

server.get('/api/test', function(req, res, next){
    Vehicle.find().exec(function(err, rows){
        res.send(rows);
    });
});

server.listen(1981);

This will return an empty array as expected.

Throwing an exception here:

server.get('/api/test', function(req, res, next){
    throw 'my exception';// <------------------------ here
    Vehicle.find().exec(function(err, rows){
        res.send(rows);
    });
});

Works as expected with the clientErrorHandler catching the exception. Instead, throwing it here:

server.get('/api/test', function(req, res, next){        
    Vehicle.find().exec(function(err, rows){
        throw 'my exception';// <------------------------ here
        res.send(rows);
    });
});

The exception is then not caught by the clientErrorHandler and is instead caught and rethrown by a mongoose/lib/util.js

exports.tick = function tick (callback) {
  if ('function' !== typeof callback) return;
  return function () {
    try {
      callback.apply(this, arguments);
    } catch (err) {
      // only nextTick on err to get out of
      // the event loop and avoid state corruption.
      process.nextTick(function () {
        throw err; //<--------------------------------- here 
      });
    }
  }
}

Doing something without mongoose such as :

server.get('/api/test', function(req, res, next){
    process.nextTick(function(){
        throw 'here';
    });
});

Also fails to be caught by express.

How do I avoid it being caught by mongoose instead of by express? How can I get express to catch the error? Can I get express to catch errors thrown on a separate tick? (Is this something I should report to express?)

I would like to avoid the process.error as I want to be able to send a message back to that user. I realize that one can call 'next' with an error, I'm more concerned about other exceptions that are from other libraries.

Problem courtesy of: Will Shaver

Solution

Rather than throwing an exception you should return an error with the next callback which can then be handled by your app’s error handler.

If you are calling functions that may throw their own errors, wrap them in a try clause and call the callback with the error you caught in catch. Here’s an example:

server.get('/api/test', function (req, res, next) {
  process.nextTick(function () {
    try {
      functionWhichWillThrowAnError();
    } catch (error) {
      next(error);
      return;
    }
    res.send('everything is okay!');
  });
});
Solution courtesy of: Todd Yandell

Discussion

I realize that one can call 'next' with an error, I'm more concerned about other exceptions that are from other libraries.

I suspect you are concerned about this because your background with other programming languages (at least that was my case.) In the end it's unlikely you'll see exceptions in asynchronous code because that just not the convention in Node.js, it's still possible but unlikely. This is from Isaac Schlueter himself:

"The pattern in node is that sync methods throw, and async methods pass the error as the first argument to the callback. If the first argument to your callback is falsey (usually null or undefined), then all is well with the world." https://groups.google.com/d/msg/nodejs/W9UVJCKcJ7Q/rzseRbourCUJ

Discussion courtesy of: Hector Correa

This recipe can be found in it's original form on Stack Over Flow.